用AutoCAD进行二次开发的自定义命令都有哪些?

2021年4月13日
评论

AutoLISP语言作为AutoCAD的二次开发工具,它易学易用,交互性好,灵活性强,对于那些经常使用CAD进行绘图的普通用户来说,不失为一种理想的开发工具。在绘图过程中,用户可根据需要,用AutoLISP方便地定义出实用的绘图命令,从而提高绘图速度。

一、键槽尺寸视图的绘制命令“jct”

在绘制轴、齿轮或带轮等零件图时,经常需要画轴上键槽处的剖视图或轮毂键槽的端面视图,比较麻烦;由于键槽的尺寸随轴径的变化而变化,所以我们可以用LISP程序来实现自动绘图。加载下面的程序,在命令行中键入”jct”并回车,通过人机交互的形式输入有关参数,可自

动完成轴上键槽的剖视图和轮毂键槽的端面视图的绘制。代码示例如下所示。
(defun C:jct ()
(setq pt0 (getpoint "\n 请输入视图的中心位置点:"))
(initget 7)
(setq loop T)
(while loop
(setq d (getreal "\n 请输入键槽处的轴径(12<d<130)(mm):"))
(if(or (< d 12) (> d 130))
(alert "轴径数据输入错误!\n\n请重新输入!")
(setq loop nil)
);if
);while
(cond;根据轴径检索键槽尺寸
((and (> d 12) (<= d 17)) (setq b 5 t1 3.0 t2 2.3));b表示键槽的宽度
((and (> d 17) (<= d 22)) (setq b 6 t1 3.5 t2 2.8));t1表示轴上键槽的深度
((and (> d 22) (<= d 30)) (setq b 8 t1 4.0 t2 3.3));t2表示轮毂上键槽的高度
((and (> d 30) (<= d 38)) (setq b 10 t1 5.0 t2 3.3))
((and (> d 38) (<= d 44)) (setq b 12 t1 5.0 t2 3.3))
((and (> d 44) (<= d 50)) (setq b 14 t1 5.5 t2 3.8))
((and (> d 50) (<= d 58)) (setq b 16 t1 6.0 t2 4.3))
((and (> d 58) (<= d 65)) (setq b 18 t1 7.0 t2 4.4))
((and (> d 65) (<= d 75)) (setq b 20 t1 7.5 t2 4.9))
((and (> d 75) (<= d 85)) (setq b 22 t1 9.0 t2 5.4))
((and (> d 85) (<= d 95)) (setq b 25 t1 9.0 t2 5.4))
((and (> d 95) (<= d 110)) (setq b 28 t1 10.0 t2 6.4))
((and (> d 110) (<= d 130)) (setq b 32 t1 11.0 t2 7.4)))
(command "circle" pt0 "d" d)
(command "zoom" "a")
(setq s1 (ssget "l" ))
(setq di (-(* (/ d 2.0) (/ d 2.0)) (* (/ b 2.0) (/ b 2.0)))
dx (sqrt di)
dy (/ b 2.0)
pt1 (list (+ (car pt0) dx) (+ (cadr pt0) dy)))
(initget "Zc Lc");Zc表示画轴键槽的剖视图,Lc表示画轮毂键槽的端面视图
(setq zrl (getkword "\n 画轴键槽的剖视图还是轮毂键槽的端面视图(Z/L)?"))
(if (= zrl "Zc")
(progn;计算轴键槽上点的坐标
(setq pt2 (list (+ (car pt0) (-(/ d 2.0) t1)) (+ (cadr pt0) dy))
pt3 (polar pt2 (- (/ pi 2.0)) b)
pt4 (pola
r pt3 0 (- dx (- (/ d 2.0) t1))))
);progn
);if
(if (= zrl "Lc")
(progn;计算轮毂键槽上点的坐标
(setq pt2 (list (+ (car pt0) (+(/ d 2.0) t2)) (+ (cadr pt0) dy))
pt3 (polar pt2 (- (/ pi 2.0)) b)
pt4 (polar pt3 (- pi) (- (+ (/ d 2.0) t2) dx)))
);progn
);if
(command "pline" pt1 pt2 pt3 pt4 "");画键槽
(setq s2 (ssget "l"))
(command "layer" "m" 5 "l" "center" 5 "c" 1 5 "")
(command "ltscale" 8)
(command "line" (polar pt0 (- pi) (+ (/ d 2.0) 10));画中心线
(polar pt0 0 (+ (/ d 2.0) 10))"")
(command "line" (polar pt0 (-(/ pi 2.0)) (+ (/ d 2.0) 10))
(polar pt0 (/ pi 2.0) (+ (/ d 2.0) 10)) "")
(command "layer" "s" 0 "")
(if (= zrl "Zc")
(progn
(setq s3 (entsel "\n 请选择修剪的目标:"))
(command "trim" s2 "" s3 "");修剪形成键槽
(command "hatch" "U" "45" "2" "n" s1 s2 ""));画轴上键槽处剖视图的剖面线
);if
(if (= zrl "Lc")
(progn
(setq s4 (entsel "\n 请选择修剪的目标:"))
(command "trim" s2 "" s4 "");修剪形成键槽
(command "rotate" s1 s2 "" pt0 90));将轮毂键槽的端面视图旋转90度
);if
);end defun

二、螺纹孔剖视图的绘制命令“lwk”

在绘制机械零件图时,经常要画螺纹孔的剖视图,同样由于螺纹孔的有关尺寸都随螺纹的公称直径而变化,我们可以用下面的程序自动完成其剖视图的绘制。加载后在命令行中键入“lwk”并回车,根据提示输入相应的参数即可。代码示例如下所示。
(defun C:lwk()
(setq pc (osnap (getpoint "\n 输入螺纹孔端面的中心点:") "near" ))
(setq ang (getangle pc "\n 螺纹孔中心线与水平线的夹角:"))
(initget 7)
(setq d (getdist "\n 请输入螺纹孔的公称直径(mm):"))
(cond;根据螺纹孔的公称直径检索有关数据(以螺纹零件的材料为钢或青铜为例)
((= d 6.0) (setq l1 10 l2 12 d2 4.917));l1表示螺纹深度
((= d 8.0) (setq l1 12 l2 16 d2 6.647));l2表示钻孔深度
((= d 10.0) (setq l1 16 l2 20 d2 8.376));d2表示螺纹小径
((= d 12.0) (setq l1 18 l2 22 d2 10.106))
((= d 14.0) (setq l1 22 l2 26 d2 11.835))
((= d 16.0) (setq l1 24 l2 28 d2 13.835))
((= d 18.0) (setq l1 28 l2 34 d2 15.29
4))
((= d 20.0) (setq l1 30 l2 35 d2 17.294))
((= d 22.0) (setq l1 32 l2 38 d2 19.294))
((= d 24.0) (setq l1 36 l2 42 d2 20.725))
((= d 27.0) (setq l1 40 l2 45 d2 23.725))
((= d 30.0) (setq l1 44 l2 52 d2 26.211))
((= d 36.0) (setq l1 52 l2 60 d2 31.670)))
(setq r2 (/ d2 2.0);计算光孔各点坐标
pt1 (polar pc (+ (/ pi 2.0) ang) r2)
pt2 (polar pt1 ang l2)
pt3 (polar pc ang (+ l2 (* 0.57735 r2)))
pt4 (polar pt2 (- ang (/ pi 2.0)) d2)
pt5 (polar pc (+ (* pi 1.5) ang) r2))
(command "pline" pt1 pt2 pt3 pt4 pt5 "c");画光孔
(setq s1 (ssget "l"))
(command "line" (polar pc (+ pi ang) 3) (polar pt3 ang 3) "");画中心线
(command "pline" pt2 pt4 "")
(setq r1 (/ d 2.0);计算螺纹线的各点坐标
pt11 (polar pc (+ (/ pi 2.0) ang) r1)
pt12 (polar pt11 ang l1)
pt13 (polar pt12 (- ang (/ pi 2.0)) d)
pt14 (polar pc (+ (* pi 1.5) ang) r1))
(command "pline" pt11 pt12 pt13 pt14 "");画螺纹线
(command "pline" pt12 pt13 "")
(setq pt21 (polar pc (+ (/ pi 2.0) ang) (+ r1 10.0));计算剖面线边界上的点坐标
pt22 (polar pt21 ang (+ l2 15.0));可根据需要设置剖面线边界的大小
pt23 (polar pt22 (- ang (/ pi 2.0)) (+ d 20.0))
pt24 (polar pc (+ (* pi 1.5) ang) (+ r1 10.0)))
(command "pline" pt21 pt22 pt23 pt24 "c");生成剖面线的边界
(setq s2 (ssget "l"))
(command "zoom" "a")
(command "hatch" "U" "45" "2" "n" s2 s1 "");画剖面线,形成消隐螺纹孔
);end

三、圆的中心线绘制命令“zxx”

在绘图中,若需要绘制已知圆的中心线,可调用下面的程序。加载后在命令行中键入“zxx”并回车,只要按提示选择圆并输入中心线的延伸长度,即可自动生成该圆的中心线,并可连续绘制。代码示例如下所示。
(defun C:zxx()
(setvar "osmode" 512)
(setq loop T)
(while loop
(setq pc (getpoint "\n 请用鼠标选择圆:"))
(setq s(ssget pc))
(if s
(progn
(setq s1(entget(ssname s 0))
pt0(cdr(assoc 10 s1));获得圆心坐标
r (cdr(assoc 40 s1));获得圆的半径
)
(setq l (getreal "\n 请输入中心线延伸长度(mm):"))
(command "layer" "m" 5 "l" "center" 5 "c" 1 5 "")
(command "ltscale" 8);设置线型比例
(command "line"
(polar pt0 (- pi) (+ r l));画中心线
(polar pt0 0 (+ r l)) "")
(command "line" (polar pt0 (-(/ pi 2.0)) (+ r l))
(polar pt0 (/ pi 2.0) (+ r l)) "")
(command "layer" "s" 0 "")
);progn
(setq loop nil)
);if
);while
);end defun
用户还可以将自定义的AutoCAD命令定制成用户菜单或工具栏,以方便使用。如,将上面介绍的几个绘图命令定制到下拉菜单中的方法是:打开AutoCAD安装目录下SUPPORT子目录中的ACAD.MNU文件,在***POP7项的最后加入下面内容,再加载已修改的菜单文件即可。
[--]
ID_User [键槽图绘制(jct)]^C^C_(if(not jct)(load "d:/Acad R14/jct.lip"));jct;^p
ID_User [螺纹孔绘制(lwk)]^C^C_(if(not lwk)(load "d:/Acad R14/lwk.lip"));lwk;^p
ID_User [中心线(zxx)]^C^C_(if(not zxx)(load "d:/Acad R14/zxx.lip"));zxx;^p

  • 小编的微信
  • 微信扫一扫
  • weinxin
  • 微信公众号
  • 微信扫一扫
  • weinxin
BIM学习网

发表评论